/*
    Valtra Tractors
    Copyright 2004 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Martin Storsj
    martin@martin.st
*/

#ifndef __WRAPPER_H
#define __WRAPPER_H

#include <SDL.h>
#include "game.h"
#include "sprites.h"
#include "point.h"
#include "dialog.h"

IPoint pointerOff[] = {
	IPoint(1,1),
	IPoint(1,1),
	IPoint(2,1)
};

class Wrapper : public GameWrapper {
private:
	Game2 *boardGame;
	bool pause;
	SpriteEngine se;
	SDL_Surface *boardSurface;
	SDL_Surface *pointer[3];
	SDL_Surface *curPointer, *lastPointer;
	SDL_Surface *front;
	Uint32 startTime, lastTime;
	IPoint curMousePos;
	IPoint curPointerOffset;
	Dialog *dialog;
	DialogType dType;
	IPoint dialogPos;
	IPoint screenSize;
	int fade, lastFade;
	bool quit;
	void showDialog(DialogType type, int data = 0);
	void initGame(SDL_Surface *screen, int time, int players);
public:
	Wrapper(SDL_Surface *screen, Uint32 time);
	~Wrapper();
	void handleEvent(SDL_Event &event);
	void update(Uint32 time, SDL_Surface *screen);
	bool finished();
	void setUpdatedRect(void (*func)(const SDL_Rect &r));
	void redraw();
	void startGame(int players);
	void setPointer(int pointer);
	void showQuitDialog();
};


#endif
